Subject: Re: [PATCH] Disable TSO for non standard qdiscs

From: Stephen Hemminger <[email-masked]>
Date: Thu, 31 Jan 2008 10:08:46 -0800

On Thu, 31 Jan 2008 19:37:35 +0100
Andi Kleen <[email-masked]> wrote:

> On Thu, Jan 31, 2008 at 07:01:00PM +0100, Patrick McHardy wrote:
> > Andi Kleen wrote:
> > >>Fix the broken qdisc instead.
> > >
> > >What do you mean? I don't think the qdiscs are broken.
> > >I cannot think of any way how e.g. TBF can do anything useful
> > >with large TSO packets.
> > 
> > 
> > Someone posted a patch some time ago to calculate the amount
> > of tokens needed in max_size portions and use that, but IMO
> > people should just configure TBF with the proper MTU for TSO.
> 
> TBF with 64k atomic units will always be chunky and uneven. I don't
> think that's a useful goal. 
> 
> -Andi

Then change TBF to use skb_gso_segment?  Be careful, the fact that
one skb ends up queueing multiple skb's would cause issues to parent
qdisc (ie work generating qdisc).

-- 
Stephen Hemminger <[email-masked]>